DROP table VinProd;
DROP table Producteur;
DROP table Vin;

CREATE TABLE Vin(
	NumVin NUMBER(5),
	Cru VARCHAR(15),
	Annee NUMBER(4),
	Degre DECIMAl(4)
);

CREATE TABLE Producteur(
	NumProd NUMBER(5),
	Nom VARCHAR(15),
	Prenom VARCHAR(15),
	Region VARCHAR2(15),
	Total NUMBER(5)
);

CREATE TABLE VinProd(
	Qte NUMBER (3),
	NumVin NUMBER(5),
	NumProd NUMBER(5)
);

-- clefs primaires
alter table Vin add constraint PK_Vin primary key(NumVin);
alter table Producteur add constraint PK_Producteur primary key(NumProd);
alter table VinProd add constraint PK_VinProd primary key(NumVin, NumProd);

-- clefs trangres
alter table VinProd add constraint FK_VinProd_Vin foreign key(NumVin) references Vin(NumVin);
alter table VinProd add constraint FK_VinProd_Producteur foreign key(NumProd) references Producteur(NumProd);

-- insertion 

insert into vin values (1, 'Bourgogne', '1998', 7.5);
insert into vin values (2, 'Beaujolais', '2003', 8.9); 
insert into vin values (3, 'cveru', '1995', 5);
insert into vin values (4, 'vth', '1997', 3.2); 

insert into producteur values (1, 'Cynthia', 'A', 'cergy', 700);
insert into producteur values (2, 'Sylvie', 'B', 'neuilly', 500); 
insert into producteur values (3, 'Thomas', 'C', 'reims', 50000);
insert into producteur values (4, 'Herv', 'D', 'bourgogne', 10000); 

-- trigger
CREATE or REPLACE Trigger trigger_recolte 
BEFORE INSERT or UPDATE ON Producteur for each row 

BEGIN 	
	:new.Total = :new.Total + :old.Total;

end;			
/